The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Types | Public Member Functions | Static Public Member Functions | List of all members
RtMidi Class Referenceabstract

An abstract base class for realtime MIDI input/output. More...

`#include <RtMidi.h>`

Inheritance diagram for RtMidi:

## Public Types
enum | Api { UNSPECIFIED, MACOSX_CORE, LINUX_ALSA, UNIX_JACK, WINDOWS_MM, RTMIDI_DUMMY, NUM_APIS }
| MIDI API specifier arguments. More...

## Public Member Functions
virtual void | openPort (unsigned int portNumber=0, const std::string &portName=std::string("RtMidi"))=0
| Pure virtual openPort() function.
virtual void | openVirtualPort (const std::string &portName=std::string("RtMidi"))=0
| Pure virtual openVirtualPort() function.
virtual unsigned int | getPortCount ()=0
| Pure virtual getPortCount() function.
virtual std::string | getPortName (unsigned int portNumber=0)=0
| Pure virtual getPortName() function.
virtual void | closePort (void)=0
| Pure virtual closePort() function.
virtual bool | isPortOpen (void) const =0
| Returns true if a port is open and false if not. More...
virtual void | setErrorCallback (RtMidiErrorCallback errorCallback=NULL, void *userData=0)=0
| Set an error callback function to be invoked when an error has occured. More...

## Static Public Member Functions
static std::string | getVersion (void) throw ()
| A static function to determine the current RtMidi version.
static void | getCompiledApi (std::vector< RtMidi::Api > &apis) throw ()
| A static function to determine the available compiled MIDI APIs. More...
static std::string | getApiName (RtMidi::Api api)
| Return the name of a specified compiled MIDI API. More...
static std::string | getApiDisplayName (RtMidi::Api api)
| Return the display name of a specified compiled MIDI API. More...
static RtMidi::Api | getCompiledApiByName (const std::string &name)
| Return the compiled MIDI API having the given name. More...

## Detailed Description

An abstract base class for realtime MIDI input/output.

This class implements some common functionality for the realtime MIDI input/output subclasses RtMidiIn and RtMidiOut.

RtMidi GitHub site: https://github.com/thestk/rtmidi RtMidi WWW site: http://www.music.mcgill.ca/~gary/rtmidi/

RtMidi: realtime MIDI i/o C++ classes Copyright (c) 2003-2019 Gary P. Scavone

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

Any person wishing to distribute modifications to the Software is asked to send the modifications to the original developer so that they can be incorporated into the canonical version. This is, however, not a binding provision of this license.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

## Member Enumeration Documentation

## ◆ Api

enum RtMidi::Api

MIDI API specifier arguments.

Enumerator
UNSPECIFIED | Search for a working compiled API.
MACOSX_CORE | Macintosh OS-X CoreMIDI API.
LINUX_ALSA | The Advanced Linux Sound Architecture API.
UNIX_JACK | The JACK Low-Latency MIDI Server API.
WINDOWS_MM | The Microsoft Multimedia MIDI API.
RTMIDI_DUMMY | A compilable but non-functional API.
NUM_APIS | Number of values in this enum.

136 {
137 UNSPECIFIED,
138 MACOSX_CORE,
139 LINUX_ALSA,
140 UNIX_JACK,
141 WINDOWS_MM,
142 RTMIDI_DUMMY,
143 NUM_APIS
144 };

## Member Function Documentation

## ◆ getCompiledApi()

static void RtMidi::getCompiledApi | ( | std::vector< RtMidi::Api > & | apis | ) |
throw | ( |
| ) |  |
| static

A static function to determine the available compiled MIDI APIs.

The values returned in the std::vector can be compared against the enumerated list values. Note that there can be more than one API compiled for certain operating systems.

## ◆ getApiName()

static std::string RtMidi::getApiName | ( | RtMidi::Api | api | ) |
| static

Return the name of a specified compiled MIDI API.

This obtains a short lower-case name used for identification purposes. This value is guaranteed to remain identical across library versions. If the API is unknown, this function will return the empty string.

## ◆ getApiDisplayName()

static std::string RtMidi::getApiDisplayName | ( | RtMidi::Api | api | ) |
| static

Return the display name of a specified compiled MIDI API.

This obtains a long name used for display purposes. If the API is unknown, this function will return the empty string.

## ◆ getCompiledApiByName()

static RtMidi::Api RtMidi::getCompiledApiByName | ( | const std::string & | name | ) |
| static

Return the compiled MIDI API having the given name.

A case insensitive comparison will check the specified name against the list of compiled APIs, and return the one which matches. On failure, the function returns UNSPECIFIED.

## ◆ isPortOpen()

virtual bool RtMidi::isPortOpen | ( | void |  | ) | const
| pure virtual

Returns true if a port is open and false if not.

Note that this only applies to connections made with the openPort() function, not to virtual ports.

Implemented in RtMidiOut, and RtMidiIn.

## ◆ setErrorCallback()

virtual void RtMidi::setErrorCallback | ( | RtMidiErrorCallback | errorCallback = `NULL`,
|  | void * | userData = `0`
| ) |  |
| pure virtual

Set an error callback function to be invoked when an error has occured.

The callback function will be called whenever an error has occured. It is best to set the error callback function before opening a port.

Implemented in RtMidiOut, and RtMidiIn.

The documentation for this class was generated from the following file:

- RtMidi.h

RtMidi::WINDOWS_MM
Definition: RtMidi.h:141
RtMidi::NUM_APIS
Definition: RtMidi.h:143
RtMidi::MACOSX_CORE
Definition: RtMidi.h:138
RtMidi::UNIX_JACK
Definition: RtMidi.h:140
RtMidi::RTMIDI_DUMMY
Definition: RtMidi.h:142
RtMidi::UNSPECIFIED
Definition: RtMidi.h:137
RtMidi::LINUX_ALSA
Definition: RtMidi.h:139

The Synthesis ToolKit in C++ (STK)
©1995--2019 Perry R. Cook and Gary P. Scavone. All Rights Reserved.